apiVersion: apps/v1
kind: Deployment
metadata:
  name: game-app
  namespace: team418
  labels:
    app: game-app
    type: backend
    role: api
spec:
  replicas: 1
  selector:
    matchLabels:
      app: game-app
      type: backend
      role: api
  template:
    metadata:
      labels:
        app: game-app
        type: backend
        role: api
    spec:
      imagePullSecrets:
        - name: gitlab-registry-config
      containers:
        - name: game-app
          image: registry.gitlab.com/code418teapot/rlthack/rlt-backend:VERSION
          env:
            - name: SPRING_PROFILES_ACTIVE
              value: production
            - name: SPRING_DATASOURCE_URL
              valueFrom:
                secretKeyRef:
                  name: database
                  key: jdbc-url
            - name: SPRING_DATASOURCE_USERNAME
              valueFrom:
                secretKeyRef:
                  name: database
                  key: username
            - name: SPRING_DATASOURCE_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: database
                  key: password
---
apiVersion: v1
kind: Service
metadata:
  name: game-app-svc
  namespace: team418
  labels:
    app: game-app
    type: backend
    role: api
spec:
  type: ClusterIP
  ports:
    - name: http
      port: 80
      targetPort: 8080
      protocol: TCP
  selector:
    app: game-app
    type: backend
    role: api
---
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: game-app-ingress
  namespace: team418
  annotations:
    kubernetes.io/ingress.class: "nginx"
    cert-manager.io/issuer: "letsencrypt-prod"
spec:
  tls:
    - hosts:
        - api.rlthack.team418.ru
      secretName: game-app-tls
  rules:
    - host: "api.rlthack.team418.ru"
      http:
        paths:
          - path: /
            pathType: Prefix
            backend:
              service:
                name: game-app-svc
                port:
                  number: 80
